{"template":"component.html","title":"Dropdown","demo":"<h4>Basic</h4>\n\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_basic\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_basic\" id=\"demo_basic\" class=\"js-dropdown\">\r\n\t\t\t\t\t<!-- <option data-label=\"Option One\">One</option>\r\n\t\t\t\t\t<option data-label=\"Option Two\">Two</option> -->\r\n\t\t\t\t\t<option value=\"1\">One</option>\r\n\t\t\t\t\t<option value=\"2\">Two</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown&quot;&gt;\r\n&Tab;&lt;option value=&quot;1&quot;&gt;One&lt;/option&gt;\r\n&Tab;&lt;option value=&quot;2&quot;&gt;Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown();</code></pre>\r\n\t</div>\r\n</div>\n\r\n<style>\r\n\t.custom_select { max-width: 500px; }\r\n\t.custom_select .fs-dropdown-selected { border-width: 2px; }\r\n\t.custom_select .fs-dropdown-options { border-width: 0 2px 2px; padding: 1%; }\r\n\t.custom_select .fs-dropdown-item { border-radius: 3px !important; border: none; margin: 0 0 1%; }\r\n\t.custom_select .fs-dropdown-item:last-child { margin: 0; }\r\n</style>\r\n\r\n<h4>Disabled</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_basic\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_basic\" id=\"demo_basic\" class=\"js-dropdown\" disabled>\r\n\t\t\t\t\t<!-- <option data-label=\"Option One\">One</option>\r\n\t\t\t\t\t<option data-label=\"Option Two\">Two</option> -->\r\n\t\t\t\t\t<option value=\"1\">One</option>\r\n\t\t\t\t\t<option value=\"2\">Two</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown&quot; disabled&gt;\r\n&Tab;&lt;option value=&quot;1&quot;&gt;One&lt;/option&gt;\r\n&Tab;&lt;option value=&quot;2&quot;&gt;Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown();</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Option Groups</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_groups\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_groups\" id=\"demo_groups\" class=\"js-dropdown\">\r\n\t\t\t\t\t<optgroup label=\"Group One\">\r\n\t\t\t\t\t\t<option value=\"1\">One</option>\r\n\t\t\t\t\t\t<option value=\"2\">Two</option>\r\n\t\t\t\t\t\t<option value=\"3\">Three</option>\r\n\t\t\t\t\t</optgroup>\r\n\t\t\t\t\t<optgroup label=\"Group One\">\r\n\t\t\t\t\t\t<option value=\"4\">Four</option>\r\n\t\t\t\t\t\t<option value=\"5\">Five</option>\r\n\t\t\t\t\t\t<option value=\"6\">Six</option>\r\n\t\t\t\t\t\t<option value=\"7\">Seven</option>\r\n\t\t\t\t\t</optgroup>\r\n\t\t\t\t\t<optgroup label=\"Group Three\">\r\n\t\t\t\t\t\t<option value=\"8\">Eight</option>\r\n\t\t\t\t\t\t<option value=\"9\">Nine</option>\r\n\t\t\t\t\t\t<option value=\"10\">Ten</option>\r\n\t\t\t\t\t</optgroup>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown&quot;&gt;\r\n&Tab;&lt;optgroup label=&quot;Group One&quot;&gt;\r\n&Tab;&Tab;&lt;option value=&quot;1&quot;&gt;One&lt;/option&gt;\r\n&Tab;&Tab;&lt;option value=&quot;2&quot;&gt;Two&lt;/option&gt;\r\n&Tab;&lt;/optgroup&gt;\r\n&Tab;&lt;optgroup label=&quot;Group Two&quot;&gt;\r\n&Tab;&Tab;&lt;option value=&quot;3&quot;&gt;Three&lt;/option&gt;\r\n&Tab;&Tab;&lt;option value=&quot;4&quot;&gt;Fout&lt;/option&gt;\r\n&Tab;&lt;/optgroup&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown();</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Multiple</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_multiple\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_multiple\" id=\"demo_multiple\" class=\"js-dropdown\" multiple>\r\n\t\t\t\t\t<option value=\"1\">One</option>\r\n\t\t\t\t\t<option value=\"2\">Two</option>\r\n\t\t\t\t\t<option value=\"3\" disabled>Three</option>\r\n\t\t\t\t\t<option value=\"4\">Four</option>\r\n\t\t\t\t\t<option value=\"5\">Five</option>\r\n\t\t\t\t\t<option value=\"6\">Six</option>\r\n\t\t\t\t\t<option value=\"7\">Seven</option>\r\n\t\t\t\t\t<option value=\"8\">Eight</option>\r\n\t\t\t\t\t<option value=\"9\">Nine</option>\r\n\t\t\t\t\t<option value=\"10\">Ten</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown&quot; multiple&gt;\r\n&Tab;&lt;option value=&quot;1&quot;&gt;One&lt;/option&gt;\r\n&Tab;&lt;option value=&quot;2&quot;&gt;Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown();</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Cover</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_cover\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_cover\" id=\"demo_cover\" class=\"js-dropdown\" data-dropdown-options='{\"cover\":\"true\"}'>\r\n\t\t\t\t\t<option value=\"1\">One</option>\r\n\t\t\t\t\t<option value=\"2\">Two</option>\r\n\t\t\t\t\t<option value=\"3\">Three</option>\r\n\t\t\t\t\t<option value=\"4\">Four</option>\r\n\t\t\t\t\t<option value=\"5\">Five</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown multiple&quot;&gt;\r\n&Tab;&lt;option value=&quot;1&quot;&gt;One&lt;/option&gt;\r\n&Tab;&lt;option value=&quot;2&quot;&gt;Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown({\r\n\tcover: true\r\n});</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Default Label</h4>\n\n<!-- START: FIRSTDEMO -->\n\n<style>\n\t.fs-dropdown { max-width: 300px; }\n</style>\n\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_label\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_label\" id=\"demo_label\" class=\"js-dropdown\" data-dropdown-options='{\"label\":\"Select A State\"}'>\r\n\t\t\t\t\t<option value=\"AL\">Alabama</option>\r\n\t\t\t\t\t<option value=\"AK\">Alaska</option>\r\n\t\t\t\t\t<option value=\"AZ\">Arizona</option>\r\n\t\t\t\t\t<option value=\"AR\">Arkansas</option>\r\n\t\t\t\t\t<option value=\"CA\">California</option>\r\n\t\t\t\t\t<option value=\"CO\">Colorado</option>\r\n\t\t\t\t\t<option value=\"CT\">Connecticut</option>\r\n\t\t\t\t\t<option value=\"DE\">Delaware</option>\r\n\t\t\t\t\t<option value=\"DC\">District Of Columbia</option>\r\n\t\t\t\t\t<option value=\"FL\">Florida</option>\r\n\t\t\t\t\t<option value=\"GA\">Georgia</option>\r\n\t\t\t\t\t<option value=\"HI\">Hawaii</option>\r\n\t\t\t\t\t<option value=\"ID\">Idaho</option>\r\n\t\t\t\t\t<option value=\"IL\">Illinois</option>\r\n\t\t\t\t\t<option value=\"IN\">Indiana</option>\r\n\t\t\t\t\t<option value=\"IA\">Iowa</option>\r\n\t\t\t\t\t<option value=\"KS\">Kansas</option>\r\n\t\t\t\t\t<option value=\"KY\">Kentucky</option>\r\n\t\t\t\t\t<option value=\"LA\">Louisiana</option>\r\n\t\t\t\t\t<option value=\"ME\">Maine</option>\r\n\t\t\t\t\t<option value=\"MD\">Maryland</option>\r\n\t\t\t\t\t<option value=\"MA\">Massachusetts</option>\r\n\t\t\t\t\t<option value=\"MI\">Michigan</option>\r\n\t\t\t\t\t<option value=\"MN\">Minnesota</option>\r\n\t\t\t\t\t<option value=\"MS\">Mississippi</option>\r\n\t\t\t\t\t<option value=\"MO\">Missouri</option>\r\n\t\t\t\t\t<option value=\"MT\">Montana</option>\r\n\t\t\t\t\t<option value=\"NE\">Nebraska</option>\r\n\t\t\t\t\t<option value=\"NV\">Nevada</option>\r\n\t\t\t\t\t<option value=\"NH\">New Hampshire</option>\r\n\t\t\t\t\t<option value=\"NJ\">New Jersey</option>\r\n\t\t\t\t\t<option value=\"NM\">New Mexico</option>\r\n\t\t\t\t\t<option value=\"NY\">New York</option>\r\n\t\t\t\t\t<option value=\"NC\">North Carolina</option>\r\n\t\t\t\t\t<option value=\"ND\">North Dakota</option>\r\n\t\t\t\t\t<option value=\"OH\">Ohio</option>\r\n\t\t\t\t\t<option value=\"OK\">Oklahoma</option>\r\n\t\t\t\t\t<option value=\"OR\">Oregon</option>\r\n\t\t\t\t\t<option value=\"PA\">Pennsylvania</option>\r\n\t\t\t\t\t<option value=\"RI\">Rhode Island</option>\r\n\t\t\t\t\t<option value=\"SC\">South Carolina</option>\r\n\t\t\t\t\t<option value=\"SD\">South Dakota</option>\r\n\t\t\t\t\t<option value=\"TN\">Tennessee</option>\r\n\t\t\t\t\t<option value=\"TX\">\tTexas</option>\r\n\t\t\t\t\t<option value=\"UT\">Utah</option>\r\n\t\t\t\t\t<option value=\"VT\">Vermont</option>\r\n\t\t\t\t\t<option value=\"VA\">Virginia</option>\r\n\t\t\t\t\t<option value=\"WA\">Washington</option>\r\n\t\t\t\t\t<option value=\"WV\">West Virginia</option>\r\n\t\t\t\t\t<option value=\"WI\">Wisconsin</option>\r\n\t\t\t\t\t<option value=\"WY\">Wyoming</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown&quot;&gt;\r\n&Tab;&lt;option value=&quot;1&quot;&gt;One&lt;/option&gt;\r\n&Tab;&lt;option value=&quot;2&quot;&gt;Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown({\r\n\tlabel: \"Select an Item\"\r\n});</code></pre>\r\n\t</div>\r\n</div>\n\n<!-- END: FIRSTDEMO -->\n\r\n<h4>Custom Labels</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_custom_1\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_custom_1\" id=\"demo_custom_1\" class=\"js-dropdown\" data-dropdown-options='{\"customClass\":\"custom\"}'>\r\n\t\t\t\t\t<option value=\"1\" data-label=\"Option One\">One</option>\r\n\t\t\t\t\t<option value=\"2\" data-label=\"Option Two\">Two</option>\r\n\t\t\t\t\t<option value=\"3\" data-label=\"Option Three\">Three</option>\r\n\t\t\t\t\t<option value=\"4\" data-label=\"Option Four\">Four</option>\r\n\t\t\t\t\t<option value=\"5\" data-label=\"Option Five\">Five</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown multiple&quot;&gt;\r\n&Tab;&lt;option value=&quot;1&quot; data-label=&quot;Option One&quot;&gt;One&lt;/option&gt;\r\n&Tab;&lt;option value=&quot;2&quot; data-label=&quot;Option Two&quot;&gt;Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown({\r\n\tcover: true\r\n});</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Custom HTML Labels</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_custom_2\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_custom_2\" id=\"demo_custom_2\" class=\"js-dropdown\" data-dropdown-options='{\"customClass\":\"custom\"}'>\r\n\t\t\t\t\t<option value=\"1\" data-label=\"&lt;em&gt;One  &lt;/em&gt;\">One</option>\r\n\t\t\t\t\t<option value=\"2\" data-label=\"&lt;em&gt;Two  &lt;/em&gt;\">Two</option>\r\n\t\t\t\t\t<option value=\"3\" data-label=\"&lt;em&gt;Three&lt;/em&gt;\">Three</option>\r\n\t\t\t\t\t<option value=\"4\" data-label=\"&lt;em&gt;Four &lt;/em&gt;\">Four</option>\r\n\t\t\t\t\t<option value=\"5\" data-label=\"&lt;em&gt;Five &lt;/em&gt;\">Five</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown multiple&quot;&gt;\r\n&Tab;&lt;option value=&quot;1&quot; data-label=&quot; &amp;lt;em&amp;gt;Option One  &amp;lt;/em&amp;gt; &quot;&gt;One&lt;/option&gt;\r\n&Tab;&lt;option value=&quot;2&quot; data-label=&quot; &amp;lt;em&amp;gt;Option Two  &amp;lt;/em&amp;gt; &quot;&gt;Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown({\r\n\tcover: true\r\n});</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Links</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_links\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_links\" id=\"demo_links\" class=\"js-dropdown\" data-dropdown-options='{\"label\":\"Jump Sites\",\"links\":true}'>\r\n\t\t\t\t\t<option value=\"http://google.com\">Google Search</option>\r\n\t\t\t\t\t<option value=\"http://boingboing.com\">Boing\tBoing</option>\r\n\t\t\t\t\t<option value=\"http://cnn.com\">CNN News</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown&quot;&gt;\r\n&Tab;&lt;option value=&quot;http://example.com&quot;&gt;Link One&lt;/option&gt;\r\n&Tab;&lt;option value=&quot;http://example.com&quot;&gt;Link Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown({\r\n\tlinks: true\r\n});</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>External Links</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_external\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_external\" id=\"demo_external\" class=\"js-dropdown\" data-dropdown-options='{\"label\":\"Jump Sites\",\"external\":\"true\"}'>\r\n\t\t\t\t\t<option value=\"http://google.com\">Google Search</option>\r\n\t\t\t\t\t<option value=\"http://boingboing.com\">Boing\tBoing</option>\r\n\t\t\t\t\t<option value=\"http://cnn.com\">CNN News</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown multiple&quot;&gt;\r\n\t&Tab;&lt;option value=&quot;http://example.com&quot;&gt;Link One&lt;/option&gt;\r\n\t&Tab;&lt;option value=&quot;http://example.com&quot;&gt;Link Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown({\r\n\texternal: true\r\n});</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>No Theme</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<form action=\"#\" method=\"GET\" class=\"form demo_form\">\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_basic_2\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_basic_2\" id=\"demo_basic_2\" class=\"js-dropdown\" data-dropdown-options='{\"theme\":\"\"}'>\r\n\t\t\t\t\t<option value=\"AL\">Alabama</option>\r\n\t\t\t\t\t<option value=\"AK\">Alaska</option>\r\n\t\t\t\t\t<option value=\"AZ\">Arizona</option>\r\n\t\t\t\t\t<option value=\"AR\">Arkansas</option>\r\n\t\t\t\t\t<option value=\"CA\">California</option>\r\n\t\t\t\t\t<option value=\"CO\">Colorado</option>\r\n\t\t\t\t\t<option value=\"CT\">Connecticut</option>\r\n\t\t\t\t\t<option value=\"DE\">Delaware</option>\r\n\t\t\t\t\t<option value=\"DC\">District Of Columbia</option>\r\n\t\t\t\t\t<option value=\"FL\">Florida</option>\r\n\t\t\t\t\t<option value=\"GA\">Georgia</option>\r\n\t\t\t\t\t<option value=\"HI\">Hawaii</option>\r\n\t\t\t\t\t<option value=\"ID\">Idaho</option>\r\n\t\t\t\t\t<option value=\"IL\">Illinois</option>\r\n\t\t\t\t\t<option value=\"IN\">Indiana</option>\r\n\t\t\t\t\t<option value=\"IA\">Iowa</option>\r\n\t\t\t\t\t<option value=\"KS\">Kansas</option>\r\n\t\t\t\t\t<option value=\"KY\">Kentucky</option>\r\n\t\t\t\t\t<option value=\"LA\">Louisiana</option>\r\n\t\t\t\t\t<option value=\"ME\">Maine</option>\r\n\t\t\t\t\t<option value=\"MD\">Maryland</option>\r\n\t\t\t\t\t<option value=\"MA\">Massachusetts</option>\r\n\t\t\t\t\t<option value=\"MI\">Michigan</option>\r\n\t\t\t\t\t<option value=\"MN\">Minnesota</option>\r\n\t\t\t\t\t<option value=\"MS\">Mississippi</option>\r\n\t\t\t\t\t<option value=\"MO\">Missouri</option>\r\n\t\t\t\t\t<option value=\"MT\">Montana</option>\r\n\t\t\t\t\t<option value=\"NE\">Nebraska</option>\r\n\t\t\t\t\t<option value=\"NV\">Nevada</option>\r\n\t\t\t\t\t<option value=\"NH\">New Hampshire</option>\r\n\t\t\t\t\t<option value=\"NJ\">New Jersey</option>\r\n\t\t\t\t\t<option value=\"NM\">New Mexico</option>\r\n\t\t\t\t\t<option value=\"NY\">New York</option>\r\n\t\t\t\t\t<option value=\"NC\">North Carolina</option>\r\n\t\t\t\t\t<option value=\"ND\">North Dakota</option>\r\n\t\t\t\t\t<option value=\"OH\">Ohio</option>\r\n\t\t\t\t\t<option value=\"OK\">Oklahoma</option>\r\n\t\t\t\t\t<option value=\"OR\">Oregon</option>\r\n\t\t\t\t\t<option value=\"PA\">Pennsylvania</option>\r\n\t\t\t\t\t<option value=\"RI\">Rhode Island</option>\r\n\t\t\t\t\t<option value=\"SC\">South Carolina</option>\r\n\t\t\t\t\t<option value=\"SD\">South Dakota</option>\r\n\t\t\t\t\t<option value=\"TN\">Tennessee</option>\r\n\t\t\t\t\t<option value=\"TX\">\tTexas</option>\r\n\t\t\t\t\t<option value=\"UT\">Utah</option>\r\n\t\t\t\t\t<option value=\"VT\">Vermont</option>\r\n\t\t\t\t\t<option value=\"VA\">Virginia</option>\r\n\t\t\t\t\t<option value=\"WA\">Washington</option>\r\n\t\t\t\t\t<option value=\"WV\">West Virginia</option>\r\n\t\t\t\t\t<option value=\"WI\">Wisconsin</option>\r\n\t\t\t\t\t<option value=\"WY\">Wyoming</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</form>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;select name=&quot;dropdown&quot; class=&quot;dropdown multiple&quot;&gt;\r\n&Tab;&lt;option value=&quot;1&quot;&gt;One&lt;/option&gt;\r\n&Tab;&lt;option value=&quot;2&quot;&gt;Two&lt;/option&gt;\r\n&lt;/select&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".dropdown\").dropdown({\r\n\ttheme: \"\"\r\n});</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n\r\n<!--\r\n\t\t<div class=\"fs-cell fs-sm-full fs-md-half fs-lg-half\">\r\n\t\t\t<h4>Detached Options</h4>\r\n\t\t\t<fieldset class=\"form_fieldset\">\r\n\t\t\t\t<label for=\"demo_detached\" class=\"form_label\">Label</label>\r\n\t\t\t\t<select name=\"demo_detached\" id=\"demo_detached\" class=\"js-dropdown\" data-dropdown-options='{\"detached\":\"true\"}'>\r\n\t\t\t\t\t<option value=\"1\">One</option>\r\n\t\t\t\t\t<option value=\"2\">Two</option>\r\n\t\t\t\t\t<option value=\"3\">Three</option>\r\n\t\t\t\t\t<option value=\"4\">Four</option>\r\n\t\t\t\t\t<option value=\"5\">Five</option>\r\n\t\t\t\t</select>\r\n\t\t\t</fieldset>\r\n\t\t</div>\r\n-->\r\n","asset_root":"../","year":2017}

 #Dropdown Demo
<p class="back_link"><a href="https://formstone.it/components/dropdown">View Documentation</a></p>