{"template":"component.html","title":"Navigation","demo":"<h4>Basic</h4>\n<p>By default, Navigation will only activate itself on screens smaller than 980px. Resize your screen if the menu is not active.</p>\n\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<h5 class=\"nav_handle nav_handle_toggle\">Menu</h5>\n\t\t<nav class=\"js-navigation\" data-navigation-handle=\".nav_handle_toggle\" data-navigation-options='{}'>\n\t\t\t<a href=\"#\">Home</a>\n\t\t\t<a href=\"#\">About</a>\n\t\t\t<a href=\"#\">Contact</a>\n\t\t</nav>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;h5 class=&quot;nav_handle&quot;&gt;Menu&lt;/h5&gt;\n&lt;nav class=&quot;navigation&quot; data-navigation-handle=&quot;.nav_handle&quot;&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;One&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Two&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Three&lt;/a&gt;\n&lt;/nav&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".navigation\").navigation();</code></pre>\n\t</div>\n</div>\n\n<h4>No Max</h4>\n\n<!-- START: FIRSTDEMO -->\n\n<style>\n\t@media screen and (min-width: 980px) {\n\t\t.nav_offscreen,\n\t\t.nav_handle {\n\t\t\tdisplay: none;\n\t\t}\n\t}\n\n\t.nav_handle.fs-navigation-overlay-handle.fs-navigation-enabled,\n\t.nav_handle.fs-navigation-reveal-handle.fs-navigation-enabled,\n\t.nav_handle.fs-navigation-push-handle.fs-navigation-enabled {\n\t\tclear: both;\n\t\tmargin-top: 10px;\n\t\tmargin-bottom: 20px;\n\t}\n</style>\n\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<h5 class=\"nav_handle nav_handle_toggle_2\">Menu</h5>\n\t\t<nav class=\"js-navigation\" data-navigation-handle=\".nav_handle_toggle_2\" data-navigation-options='{\"maxWidth\":\"10000px\"}'>\n\t\t\t<a href=\"#\">Home</a>\n\t\t\t<a href=\"#\">About</a>\n\t\t\t<a href=\"#\">Contact</a>\n\t\t</nav>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;h5 class=&quot;nav_handle&quot;&gt;Menu&lt;/h5&gt;\n&lt;nav class=&quot;navigation&quot; data-navigation-handle=&quot;.nav_handle&quot;&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;One&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Two&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Three&lt;/a&gt;\n&lt;/nav&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".navigation\").navigation({\n\tmaxWidth: \"10000px\"\n});</code></pre>\n\t</div>\n</div>\n\n<!-- END: FIRSTDEMO -->\n\n<h4>No Theme</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<h5 class=\"nav_handle nav_handle_toggle2\">Menu</h5>\n\t\t<nav class=\"js-navigation\" data-navigation-handle=\".nav_handle_toggle2\" data-navigation-options='{\"theme\":\"\"}'>\n\t\t\t<a href=\"#\">Home</a>\n\t\t\t<a href=\"#\">About</a>\n\t\t\t<a href=\"#\">Contact</a>\n\t\t</nav>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;h5 class=&quot;nav_handle&quot;&gt;Menu&lt;/h5&gt;\n&lt;nav class=&quot;navigation&quot; data-navigation-handle=&quot;.nav_handle&quot;&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;One&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Two&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Three&lt;/a&gt;\n&lt;/nav&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".navigation\").navigation({\n\ttheme: \"\"\n});</code></pre>\n\t</div>\n</div>\n\n<h4>Off Canvas - Overlay Left</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<button type=\"button\" class=\"button nav_handle nav_handle_overlay_left\">Menu</button>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;div class=&quot;nav_content&quot;&gt;\n&Tab;&lt;button type=&quot;button&quot; class=&quot;nav_handle&quot;&gt;Menu&lt;/button&gt;\n&lt;/div&gt;\n&lt;nav class=&quot;navigation&quot; data-navigation-handle=&quot;.nav_handle&quot; data-navigation-content=&quot;.nav_content&quot;&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;One&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Two&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Three&lt;/a&gt;\n&lt;/nav&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".navigation\").navigation({\n\ttype: \"overlay\",\n\tgravity: \"left\",\n\tmaxWidth: \"10000px\"\n});</code></pre>\n\t</div>\n</div>\n\n<h4>Off Canvas - Overlay Right</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<button type=\"button\" class=\"button nav_handle nav_handle_overlay_right\">Menu</button>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;div class=&quot;nav_content&quot;&gt;\n&Tab;&lt;button type=&quot;button&quot; class=&quot;nav_handle&quot;&gt;Menu&lt;/button&gt;\n&lt;/div&gt;\n&lt;nav class=&quot;navigation&quot; data-navigation-handle=&quot;.nav_handle&quot; data-navigation-content=&quot;.nav_content&quot;&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;One&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Two&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Three&lt;/a&gt;\n&lt;/nav&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".navigation\").navigation({\n\ttype: \"overlay\",\n\tgravity: \"right\",\n\tmaxWidth: \"10000px\"\n});</code></pre>\n\t</div>\n</div>\n\n<h4>Off Canvas - Reveal Left</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<button type=\"button\" class=\"button nav_handle nav_handle_reveal_left\">Menu</button>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;div class=&quot;nav_content&quot;&gt;\n&Tab;&lt;button type=&quot;button&quot; class=&quot;nav_handle&quot;&gt;Menu&lt;/button&gt;\n&lt;/div&gt;\n&lt;nav class=&quot;navigation&quot; data-navigation-handle=&quot;.nav_handle&quot; data-navigation-content=&quot;.nav_content&quot;&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;One&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Two&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Three&lt;/a&gt;\n&lt;/nav&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".navigation\").navigation({\n\ttype: \"reveal\",\n\tgravity: \"left\",\n\tmaxWidth: \"10000px\"\n});</code></pre>\n\t</div>\n</div>\n\n<h4>Off Canvas - Reveal Right</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<button type=\"button\" class=\"button nav_handle nav_handle_reveal_right\">Menu</button>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;div class=&quot;nav_content&quot;&gt;\n&Tab;&lt;button type=&quot;button&quot; class=&quot;nav_handle&quot;&gt;Menu&lt;/button&gt;\n&lt;/div&gt;\n&lt;nav class=&quot;navigation&quot; data-navigation-handle=&quot;.nav_handle&quot; data-navigation-content=&quot;.nav_content&quot;&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;One&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Two&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Three&lt;/a&gt;\n&lt;/nav&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".navigation\").navigation({\n\ttype: \"reveal\",\n\tgravity: \"right\",\n\tmaxWidth: \"10000px\"\n});</code></pre>\n\t</div>\n</div>\n\n<h4>Off Canvas - Push Left</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<button type=\"button\" class=\"button nav_handle nav_handle_push_left\">Menu</button>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;div class=&quot;nav_content&quot;&gt;\n&Tab;&lt;button type=&quot;button&quot; class=&quot;nav_handle&quot;&gt;Menu&lt;/button&gt;\n&lt;/div&gt;\n&lt;nav class=&quot;navigation&quot; data-navigation-handle=&quot;.nav_handle&quot; data-navigation-content=&quot;.nav_content&quot;&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;One&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Two&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Three&lt;/a&gt;\n&lt;/nav&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".navigation\").navigation({\n\ttype: \"push\",\n\tgravity: \"left\",\n\tmaxWidth: \"10000px\"\n});</code></pre>\n\t</div>\n</div>\n\n<h4>Off Canvas - Push Right</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<button type=\"button\" class=\"button nav_handle nav_handle_push_right\">Menu</button>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;div class=&quot;nav_content&quot;&gt;\n&Tab;&lt;button type=&quot;button&quot; class=&quot;nav_handle&quot;&gt;Menu&lt;/button&gt;\n&lt;/div&gt;\n&lt;nav class=&quot;navigation&quot; data-navigation-handle=&quot;.nav_handle&quot; data-navigation-content=&quot;.nav_content&quot;&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;One&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Two&lt;/a&gt;\n&Tab;&lt;a href=&quot;#&quot;&gt;Three&lt;/a&gt;\n&lt;/nav&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".navigation\").navigation({\n\ttype: \"push\",\n\tgravity: \"right\",\n\tmaxWidth: \"10000px\"\n});</code></pre>\n\t</div>\n</div>\n\n\n<div class=\"js-navigation_elements\">\n\n\t<nav class=\"nav_offscreen js-navigation\" data-navigation-handle=\".nav_handle_overlay_left\" data-navigation-content=\".demo_content\" data-navigation-options='{\"type\":\"overlay\",\"gravity\":\"left\",\"maxWidth\":\"10000px\"}'>\n\t\tOverlay Left\n\t</nav>\n\n\t<nav class=\"nav_offscreen js-navigation\" data-navigation-handle=\".nav_handle_overlay_right\" data-navigation-content=\".demo_content\" data-navigation-options='{\"type\":\"overlay\",\"gravity\":\"right\",\"maxWidth\":\"10000px\"}'>\n\t\tOverlay Right\n\t</nav>\n\n\t<nav class=\"nav_offscreen js-navigation\" data-navigation-handle=\".nav_handle_reveal_left\" data-navigation-content=\".demo_content\" data-navigation-options='{\"type\":\"reveal\",\"gravity\":\"left\",\"maxWidth\":\"10000px\"}'>\n\t\tReveal Left\n\t</nav>\n\n\t<nav class=\"nav_offscreen js-navigation\" data-navigation-handle=\".nav_handle_reveal_right\" data-navigation-content=\".demo_content\" data-navigation-options='{\"type\":\"reveal\",\"gravity\":\"right\",\"maxWidth\":\"10000px\"}'>\n\t\tReveal Right\n\t</nav>\n\n\t<nav class=\"nav_offscreen js-navigation\" data-navigation-handle=\".nav_handle_push_left\" data-navigation-content=\".demo_content\" data-navigation-options='{\"type\":\"push\",\"gravity\":\"left\",\"maxWidth\":\"10000px\"}'>\n\t\tPush Left\n\t</nav>\n\n\t<nav class=\"nav_offscreen js-navigation\" data-navigation-handle=\".nav_handle_push_right\" data-navigation-content=\".demo_content\" data-navigation-options='{\"type\":\"push\",\"gravity\":\"right\",\"maxWidth\":\"10000px\"}'>\n\t\tPush Right\n\t</nav>\n</div>\n","asset_root":"../","year":2017}

 #Navigation Demo
<p class="back_link"><a href="https://formstone.it/components/navigation">View Documentation</a></p>