{"template":"component.html","title":"Swap","demo":"<h4>Basic</h4>\r\n\r\n<!-- START: FIRSTDEMO -->\r\n\r\n<style>\r\n\t.demo_content .toggle { cursor: pointer; display: none; margin: 10px 0; }\r\n\t.demo_content .toggle.fs-swap-enabled { display: block; }\r\n\t.toggle,\r\n\t.no-touch .toggle:hover { background: #B0BEC5; }\r\n\t.toggle.fs-swap-active,\r\n\t.no-touch .toggle.fs-swap-active:hover { background: #00bcd4; }\r\n\r\n\t.toggle_target { background: #00bcd4; border-radius: 3px; color: #fff; height: 75px; line-height: 75px; margin: 10px 0; text-align: center; width: 100%; }\r\n\t.toggle_target.fs-swap-enabled.fs-swap-target { display: none; }\r\n\t.toggle_target.fs-swap-enabled.fs-swap-active { display: block; }\r\n</style>\r\n\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<div class=\"button toggle js-swap\" data-swap-target=\".toggle_target_0\">Handle</div>\r\n\t\t<div class=\"toggle_target toggle_target_0\">Content</div>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;h2 class=&quot;swap&quot; data-swap-target=&quot;.swap_target&quot;&gt;Handle&lt;/h2&gt;\r\n&lt;div class=&quot;swap_target&quot;&gt;Content&lt;/div&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".swap\").swap();</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<!-- END: FIRSTDEMO -->\r\n\r\n<h4>Grouped</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<div class=\"button toggle js-swap\" data-swap-target=\".toggle_target_1\" data-swap-group=\"toggle_group_1\">Handle 1</div>\r\n\t\t<div class=\"toggle_target toggle_target_1\">Content 1</div>\r\n\r\n\t\t<div class=\"button toggle js-swap\" data-swap-target=\".toggle_target_2\" data-swap-group=\"toggle_group_1\">Handle 2</div>\r\n\t\t<div class=\"toggle_target toggle_target_2\">Content 2</div>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;h2 class=&quot;swap&quot; data-swap-target=&quot;.swap_target_1&quot; data-swap-group=&quot;swap_group&quot;&gt;Handle 1&lt;/h2&gt;\r\n&lt;div class=&quot;swap_target_1&quot;&gt;Content 1&lt;/div&gt;\r\n\r\n&lt;h2 class=&quot;swap&quot; data-swap-target=&quot;.toggle_target_2&quot; data-swap-group=&quot;swap_group&quot;&gt;Handle 2&lt;/h2&gt;\r\n&lt;div class=&quot;swap_target_2&quot;&gt;Content 2&lt;/div&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".swap\").swap();</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Grouped (no collapse)</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<div class=\"button toggle js-swap\" data-swap-options='{\"collapse\":false}' data-swap-target=\".toggle_target_3\" data-swap-group=\"toggle_group_2\">Handle 1</div>\r\n\t\t<div class=\"toggle_target toggle_target_3\">Content 1</div>\r\n\r\n\t\t<div class=\"button toggle js-swap\" data-swap-options='{\"collapse\":false}' data-swap-target=\".toggle_target_4\" data-swap-group=\"toggle_group_2\" data-swap-active=\"true\">Handle 2</div>\r\n\t\t<div class=\"toggle_target toggle_target_4\">Content 2</div>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;h2 class=&quot;swap&quot; data-swap-target=&quot;.swap_target_1&quot; data-swap-group=&quot;swap_group&quot;&gt;Handle 1&lt;/h2&gt;\r\n&lt;div class=&quot;swap_target_1&quot;&gt;Content 1&lt;/div&gt;\r\n\r\n&lt;h2 class=&quot;swap&quot; data-swap-target=&quot;.swap_target_2&quot; data-swap-group=&quot;swap_group&quot; data-swap-active=&quot;true&quot;&gt;Handle 2&lt;/h2&gt;\r\n&lt;div class=&quot;swap_target_2&quot;&gt;Content 2&lt;/div&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".swap\").swap({\r\n\tcollapse: false\r\n});</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Max Width</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<div class=\"button toggle js-swap\" data-swap-options='{\"maxWidth\":\"740px\"}' data-swap-target=\".toggle_target_5\">Handle</div>\r\n\t\t<div class=\"toggle_target toggle_target_5\">Content</div>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;h2 class=&quot;swap&quot; data-swap-target=&quot;.swap_target&quot;&gt;Handle&lt;/h2&gt;\r\n&lt;div class=&quot;swap_target&quot;&gt;Content&lt;/div&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".swap\").swap({\r\n\tmaxWidth: \"740px\"\r\n});</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Linked Handles</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<div class=\"button toggle js-swap\" data-swap-target=\".toggle_target_6\" data-swap-linked=\"toggle_linked\" data-swap-group=\"toggle_group_3\">Handle 1 - Group 1</div>\r\n\t\t<div class=\"toggle_target toggle_target_6\">Content</div>\r\n\t\t<div class=\"button toggle js-swap\" data-swap-target=\".toggle_target_6\" data-swap-linked=\"toggle_linked\" data-swap-group=\"toggle_group_3\">Handle 2 - Group 1</div>\r\n\r\n\t\t<div class=\"button toggle js-swap\" data-swap-target=\".toggle_target_7\" data-swap-linked=\"toggle_linked_2\" data-swap-group=\"toggle_group_3\">Handle 1 - Group 2</div>\r\n\t\t<div class=\"toggle_target toggle_target_7\">Content 2</div>\r\n\t\t<div class=\"button toggle js-swap\" data-swap-target=\".toggle_target_7\" data-swap-linked=\"toggle_linked_2\" data-swap-group=\"toggle_group_3\">Handle 2 - Group 2</div>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;h2 class=&quot;swap&quot; data-swap-target=&quot;.swap_target_1&quot; data-swap-linked=&quot;swap_linked_1&quot; data-swap-group=&quot;swap_group&quot;&gt;Handle 1 - Group 1&lt;/h2&gt;\r\n&lt;div class=&quot;swap_target_1&quot;&gt;Content&lt;/div&gt;\r\n&lt;span class=&quot;swap&quot; data-swap-target=&quot;.swap_target_1&quot; data-swap-linked=&quot;swap_linked_1&quot; data-swap-group=&quot;swap_group&quot;&gt;Handle 2 - Group 1&lt;/span&gt;\r\n\r\n&lt;h2 class=&quot;swap&quot; data-swap-target=&quot;.swap_target_2&quot; data-swap-linked=&quot;swap_linked_2&quot; data-swap-group=&quot;swap_group&quot;&gt;Handle 1 - Group 2&lt;/h2&gt;\r\n&lt;div class=&quot;swap_target_2&quot;&gt;Content 2&lt;/div&gt;\r\n&lt;span class=&quot;swap&quot; data-swap-target=&quot;.swap_target_2&quot; data-swap-linked=&quot;swap_linked_2&quot; data-swap-group=&quot;swap_group&quot;&gt;Handle 2 - Group 2&lt;/span&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".swap\").swap();</code></pre>\r\n\t</div>\r\n</div>\r\n","asset_root":"../","year":2017}

 #Swap Demo
<p class="back_link"><a href="https://formstone.it/components/swap">View Documentation</a></p>