{"template":"component.html","title":"Tooltip","demo":"<h4>Basic</h4>\n\n<!-- START: FIRSTDEMO -->\n\n<style>\n\t.center { text-align: center; }\n\n\t.tooltips { margin: 20px 0; overflow: hidden; }\n\n\t.tooltip { background: #00bcd4; border-radius: 3px; color: #fff; clear: both; display: block; height: 50px; line-height: 50px; margin: 0 auto 10px; text-align: center; width: 50%; }\n\t.long_text .fs-tooltip-content { width: 250px; white-space: normal; }\n</style>\n\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<div class=\"tooltips\">\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Left Tooltip\"   data-tooltip-options='{\"direction\":\"left\"}'>Left</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Right Tooltip\"  data-tooltip-options='{\"direction\":\"right\"}'>Right</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Top Tooltip\"    data-tooltip-options='{\"direction\":\"top\"}'>Top</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Bottom Tooltip\" data-tooltip-options='{\"direction\":\"bottom\"}'>Bottom</div>\n\t\t</div>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;a href=&quot;page.html&quot; class=&quot;tooltip&quot; data-title=&quot;Tooltip Content&quot;&gt;Tooltip Handle&lt;/a&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".tooltip\").tooltip({\n\tdirection: \"top\"\n});</code></pre>\n\t</div>\n</div>\n\n<!-- END: FIRSTDEMO -->\n\n<h4>Follow</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<div class=\"tooltips\">\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Left Tooltip\"    data-tooltip-options='{\"direction\":\"left\",\"follow\":\"true\"}'>Left</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Right Tooltip\"   data-tooltip-options='{\"direction\":\"right\",\"follow\":\"true\"}'>Right</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Top Tooltip\"     data-tooltip-options='{\"direction\":\"top\",\"follow\":\"true\"}'>Top</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Bottom Tooltip\"  data-tooltip-options='{\"direction\":\"bottom\",\"follow\":\"true\"}'>Bottom</div>\n\t\t</div>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;a href=&quot;page.html&quot; class=&quot;tooltip&quot; data-title=&quot;Tooltip Content&quot;&gt;Tooltip Handle&lt;/a&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".tooltip\").tooltip({\n\tdirection: \"left\",\n\tfollow: true\n});</code></pre>\n\t</div>\n</div>\n\n<h4>Match</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<div class=\"tooltips\">\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Left Tooltip\"    data-tooltip-options='{\"direction\":\"left\",\"match\":\"true\"}'>Left</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Right Tooltip\"   data-tooltip-options='{\"direction\":\"right\",\"match\":\"true\"}'>Right</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Top Tooltip\"     data-tooltip-options='{\"direction\":\"top\",\"match\":\"true\"}'>Top</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Bottom Tooltip\"  data-tooltip-options='{\"direction\":\"bottom\",\"match\":\"true\"}'>Bottom</div>\n\t\t</div>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;a href=&quot;page.html&quot; class=&quot;tooltip&quot; data-title=&quot;Tooltip Content&quot;&gt;Tooltip Handle&lt;/a&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".tooltip\").tooltip({\n\tdirection: \"bottom\",\n\tmatch: true\n});</code></pre>\n\t</div>\n</div>\n\n<h4>Delay</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<div class=\"tooltips\">\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Left Tooltip\"    data-tooltip-options='{\"direction\":\"left\",\"delay\":\"500\"}'>Left</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Right Tooltip\"   data-tooltip-options='{\"direction\":\"right\",\"delay\":\"500\"}'>Right</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Top Tooltip\"     data-tooltip-options='{\"direction\":\"top\",\"delay\":\"500\"}'>Top</div>\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Bottom Tooltip\"  data-tooltip-options='{\"direction\":\"bottom\",\"delay\":\"500\"}'>Bottom</div>\n\t\t</div>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;a href=&quot;page.html&quot; class=&quot;tooltip&quot; data-title=&quot;Tooltip Content&quot;&gt;Tooltip Handle&lt;/a&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".tooltip\").tooltip({\n\tdirection: \"right\",\n\tdelay: 500\n});</code></pre>\n\t</div>\n</div>\n\n<!-- <h4>Long Text</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<div class=\"tooltips\">\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Maecenas faucibus mollis interdum. Vestibulum id ligula porta felis euismod semper. \" data-tooltip-options='{\"customClass\":\"long_text\",\"direction\":\"top\"}'>Left</div>\n\t\t</div>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\"></code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".tooltip\").tooltip({\n\n});</code></pre>\n\t</div>\n</div> -->\n\n<h4>No Theme</h4>\n<div class=\"demo_container\">\n\t<div class=\"demo_example\">\n\t\t<div class=\"tooltips\">\n\t\t\t<div class=\"tooltip js-tooltip\" data-title=\"No Theme\" data-tooltip-options='{\"theme\":\"\",\"direction\":\"bottom\"}'>No Theme</div>\n\t\t</div>\n\t</div>\n\t<div class=\"demo_code\">\n\t\t<pre><code class=\"language-html\">&lt;a href=&quot;page.html&quot; class=&quot;tooltip&quot; data-title=&quot;Tooltip Content&quot;&gt;Tooltip Handle&lt;/a&gt;</code></pre>\n\t\t<pre><code class=\"language-javascript\">$(\".tooltip\").tooltip({\n\tdirection: \"top\",\n\ttheme: \"\"\n});</code></pre>\n\t</div>\n</div>\n","asset_root":"../","year":2017}

 #Tooltip Demo
<p class="back_link"><a href="https://formstone.it/components/tooltip">View Documentation</a></p>