{"template":"component.html","title":"Transition","demo":"<h4>Basic</h4>\r\n\r\n<!-- START: FIRSTDEMO -->\r\n\r\n<style>\r\n\t.transitions { margin: 0 0 20px; }\r\n\t.transition_track { background: #fff; border: 1px solid #455a64; margin: 20px 0; }\r\n\t.transition { background-color: #00bcd4; height: 30px; width: 10%;\r\n\t\t-webkit-transition: margin 0.5s ease, height 0.5s linear 0.5s;\r\n\t\t\t\ttransition: margin 0.5s ease, height 0.5s linear 0.5s;\r\n\t}\r\n\t.transition.move { margin-left: 90%; }\r\n\t.transition_property.move {\r\n\t\theight: 50px;\r\n\t}\r\n\r\n\t.output { display: inline-block; margin: 0 0 0 10px; }\r\n</style>\r\n\r\n<script>\r\n\t$(function() {\r\n\t\t$(\".transition_basic\").transition({\r\n\t\t\talways: true\r\n\t\t}, complete);\r\n\r\n\t\t$(\".transition_parent\").transition({\r\n\t\t\talways: true,\r\n\t\t\ttarget: \".transition_delegate\"\r\n\t\t}, complete);\r\n\r\n\t\t$(\".transition_property\").transition({\r\n\t\t\talways: true,\r\n\t\t\tproperty: \"height\"\r\n\t\t}, complete);\r\n\r\n\t\t$(\".trigger\").on(\"click\", start);\r\n\t});\r\n\r\n\tfunction start() {\r\n\t\tvar $target = $(this).parent(\".transitions\").find(\".transition\");\r\n\r\n\t\tif (!$target.hasClass(\"animating\")) {\r\n\t\t\t$target.toggleClass(\"move\")\r\n\t\t\t\t   .addClass(\"animating\");\r\n\r\n\t\t\toutput($target, \" \");\r\n\t\t}\r\n\t}\r\n\r\n\tfunction complete() {\r\n\t\tvar $target = $(this);\r\n\r\n\t\tif (!$target.hasClass(\"transition\")) {\r\n\t\t\t$target = $(this).find(\".transition\");\r\n\t\t}\r\n\r\n\t\t$target.removeClass(\"animating\");\r\n\t\toutput($target, \"Complete\");\r\n\t}\r\n\r\n\tfunction output($target, text) {\r\n\t\t$target.parents(\".transitions\").find(\".output\").text(text);\r\n\t}\r\n</script>\r\n\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<div class=\"transitions\">\r\n\t\t\t<div class=\"transition_track\">\r\n\t\t\t\t<div class=\"transition transition_basic\"></div>\r\n\t\t\t</div>\r\n\t\t\t<button class=\"button trigger\">Start</button>\r\n\t\t\t<div class=\"output\">&nbsp;</div>\r\n\t\t</div>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;div class=&quot;transition_target&quot;&gt;&lt;/div&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".transition_target\").transition({\r\n\talways: true\r\n}, function() {\r\n\t// Tranition complete...\r\n}).addClass(\"active\");</code></pre>\r\n\t\t<pre><code class=\"language-css\">.transition_target {\r\n\tbackground: black;\r\n\ttransition: background 0.25s;\r\n}\r\n\r\n.transition_target.active {\r\n\tbackground: blue;\r\n}</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n\r\n<!-- END: FIRSTDEMO -->\r\n\r\n<h4>Delegation</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<div class=\"transitions\">\r\n\t\t\t<div class=\"transition_track transition_parent\">\r\n\t\t\t\t<div class=\"transition transition_delegate\"></div>\r\n\t\t\t</div>\r\n\t\t\t<button class=\"button trigger\">Start</button>\r\n\t\t\t<div class=\"output\">&nbsp;</div>\r\n\t\t</div>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;div class=&quot;transition_target&quot;&gt;\r\n&Tab;&lt;div class=&quot;transition_child&quot;&gt;&lt;/div&gt;\r\n&lt;/div&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".transition_target\").transition({\r\n\talways: true,\r\n\ttarget: \".transition_child\"\r\n}, function() {\r\n\t// Tranition complete...\r\n}).addClass(\"active\");</code></pre>\r\n\t\t<pre><code class=\"language-css\">.transition_target .transition_child {\r\n\tbackground: black;\r\n\ttransition: background 0.25s;\r\n}\r\n\r\n.transition_target.active .transition_child {\r\n\tbackground: blue;\r\n}</code></pre>\r\n\t</div>\r\n</div>\r\n\r\n<h4>Property</h4>\r\n<div class=\"demo_container\">\r\n\t<div class=\"demo_example\">\r\n\t\t<div class=\"transitions\">\r\n\t\t\t<div class=\"transition_track\">\r\n\t\t\t\t<div class=\"transition transition_property\"></div>\r\n\t\t\t</div>\r\n\t\t\t<button class=\"button trigger\">Start</button>\r\n\t\t\t<div class=\"output\">&nbsp;</div>\r\n\t\t</div>\r\n\t</div>\r\n\t<div class=\"demo_code\">\r\n\t\t<pre><code class=\"language-html\">&lt;div class=&quot;transition_target&quot;&gt;&lt;/div&gt;</code></pre>\r\n\t\t<pre><code class=\"language-javascript\">$(\".transition_target\").transition({\r\n\talways: true,\r\n\tproperty: \"height\"\r\n}, function() {\r\n\t// Tranition complete...\r\n}).addClass(\"active\");</code></pre>\r\n\t\t<pre><code class=\"language-css\">.transition_target {\r\n\tbackground: black;\r\n\theight: 10px;\r\n\ttransition:\r\n\t\tbackground 0.25s linear 0s,\r\n\t\theight 0.25s linear 1s;\r\n}\r\n\r\n.transition_target.active {\r\n\tbackground: blue;\r\n\theight: 30px;\r\n}</code></pre>\r\n\t</div>\r\n</div>\r\n","asset_root":"../","year":2017}

 #Transition Demo
<p class="back_link"><a href="https://formstone.it/components/transition">View Documentation</a></p>